diff -urN src/gtk2/gui/guiTemplates.mli src/gtk2/gui/guiTemplates.mli
--- src/gtk2/gui/guiTemplates.mli	2005-03-02 20:45:12.000000000 +0100
+++ src/gtk2/gui/guiTemplates.mli	2005-09-25 10:41:40.000000000 +0200
@@ -28,6 +28,8 @@
 (*************************************************************************)
 (*************************************************************************)
 
+type key = string
+
 module Gview :
   functor
     (V : sig
@@ -44,7 +46,6 @@
              end
 
            type item
-           type key
 
            val columns     : (Column.column * float) list Options.option_record
            val get_key     : item -> key
@@ -58,7 +59,7 @@
           inherit GTree.model
           method content : GTree.view_column -> V.Column.column -> unit
           method expanded_paths : int array list
-          method get_item : Gtk.tree_iter -> V.item
+          method find_model_key : Gtk.tree_iter -> key
           method sort : V.Column.column -> Gtk.Tags.sort_type option -> unit
           method set_view : g_view -> unit
           method unset_view : g_view -> unit
@@ -79,18 +80,19 @@
           method virtual from_item : Gtk.tree_iter -> V.item -> unit
           method virtual from_new_item : Gtk.tree_iter -> V.item -> V.item -> unit
           method virtual content : GTree.view_column -> V.Column.column -> unit
-          method virtual sort_items : V.Column.column -> V.item -> V.item -> int
+          method virtual sort_items : V.Column.column -> key -> key -> int
           method add_item : V.item -> Gtk.tree_iter
-          method all_items : unit -> V.item list
+          method all_items : unit -> key list
           method clear : unit -> unit
           method expanded_paths : int array list
-          method find_item : V.key -> (Gtk.tree_iter * V.item)
-          method get_item : Gtk.tree_iter -> V.item
+          method find_key : Gtk.tree_iter -> key
+          method find_model_key : Gtk.tree_iter -> key
+          method find_row : key -> Gtk.tree_iter
           method gmodel : g_model
           method nitems : int
           method refresh_filter : unit -> unit
-          method remove_item : V.item -> unit
-          method set_filter : (V.item -> bool) -> unit
+          method remove_item : key -> unit
+          method set_filter : (key -> bool) -> unit
           method set_view : g_view -> unit
           method sort : V.Column.column -> Gtk.Tags.sort_type option -> unit
           method unset_view : g_view -> unit
@@ -104,18 +106,19 @@
           method virtual from_item : Gtk.tree_iter -> V.item -> unit
           method virtual from_new_item : Gtk.tree_iter -> V.item -> V.item -> unit
           method virtual content : GTree.view_column -> V.Column.column -> unit
-          method virtual sort_items : V.Column.column -> V.item -> V.item -> int
+          method virtual sort_items : V.Column.column -> key -> key -> int
           method add_item : V.item -> ?parent:Gtk.tree_iter -> unit -> Gtk.tree_iter
-          method all_items : unit -> V.item list
+          method all_items : unit -> key list
           method clear : unit -> unit
           method expanded_paths : int array list
-          method find_item : V.key -> (Gtk.tree_iter * V.item)
-          method get_item : Gtk.tree_iter -> V.item
+          method find_key : Gtk.tree_iter -> key
+          method find_model_key : Gtk.tree_iter -> key
+          method find_row : key -> Gtk.tree_iter
           method gmodel : g_model
           method nitems : int
           method refresh_filter : unit -> unit
-          method remove_item : V.item -> unit
-          method set_filter : (V.item -> bool) -> unit
+          method remove_item : key -> unit
+          method set_filter : (key -> bool) -> unit
           method set_view : g_view -> unit
           method sort : V.Column.column -> Gtk.Tags.sort_type option -> unit
           method unset_view : g_view -> unit
@@ -128,14 +131,14 @@
           method expanded_paths : int array list
           method gview : g_view
           method id : int
-          method set_menu : (V.item list -> GToolbox.menu_entry list) -> unit
+          method set_menu : (key list -> GToolbox.menu_entry list) -> unit
           method set_model : g_model -> unit
-          method set_on_collapse : (Gtk.tree_path -> V.item -> bool) -> unit
-          method set_on_collapsed : (Gtk.tree_path -> V.item -> unit) -> unit
-          method set_on_double_click : (V.item -> unit) -> unit
-          method set_on_expand : (Gtk.tree_path -> V.item -> bool) -> unit
-          method set_on_expanded : (Gtk.tree_path -> V.item -> unit) -> unit
-          method set_on_select : (V.item list -> unit) -> unit
+          method set_on_collapse : (Gtk.tree_path -> key -> bool) -> unit
+          method set_on_collapsed : (Gtk.tree_path -> key -> unit) -> unit
+          method set_on_double_click : (key -> unit) -> unit
+          method set_on_expand : (Gtk.tree_path -> key -> bool) -> unit
+          method set_on_expanded : (Gtk.tree_path -> key -> unit) -> unit
+          method set_on_select : (key list -> unit) -> unit
           method set_selection_mode : Gtk.Tags.selection_mode -> unit
           method unset_model : unit -> unit
           method view : GTree.view
diff -urN src/gtk2/gui/guiTools.ml src/gtk2/gui/guiTools.ml
--- src/gtk2/gui/guiTools.ml	2005-07-13 01:10:16.000000000 +0200
+++ src/gtk2/gui/guiTools.ml	2005-10-12 16:45:04.000000000 +0200
@@ -432,36 +432,37 @@
 *)
 
 let fit_string_to_pixels s ~context ~pixels =
-  let us = U.utf8_of s in
-  let pango_layout = Pango.Layout.create context#as_context in
-  Pango.Layout.set_text pango_layout us;
-  let us' =
-    if fst (Pango.Layout.get_pixel_size pango_layout) <= pixels
-    then us
+  if s = ""
+    then s
     else begin
-      let len = Glib.Utf8.length us in
-      let uca = Glib.Utf8.to_unistring us in
-      let uca_ext = Array.sub uca (len - 7) 7 in
-      let ext = "..." ^ (Glib.Utf8.from_unistring uca_ext) in
-      let rec adjust_string n len =
-        if n = len
-          then us
-          else begin
-            let ustr = (Glib.Utf8.from_unistring (Array.sub uca 0 n)) ^ ext in
-            Pango.Layout.set_text pango_layout ustr;
-            let ustr_pixels = fst (Pango.Layout.get_pixel_size pango_layout) in
-            (* Printf.printf "width %d - Pango.Layout.get_pixel_size %d Pango.Layout.get_text %s\n" 
-               pixels s_width (Pango.Layout.get_text pango_layout);
-            flush stdout; *)
-            if ustr_pixels < pixels
-              then adjust_string (n + 1) len
-              else ustr
-          end
-      in
-      adjust_string 0 len
+      let us = U.utf8_of s in
+      let pango_layout = Pango.Layout.create context#as_context in
+      Pango.Layout.set_text pango_layout us;
+      let us' =
+        if fst (Pango.Layout.get_pixel_size pango_layout) <= pixels
+        then us
+        else begin
+          let len = Glib.Utf8.length us in
+          let uca = Glib.Utf8.to_unistring us in
+          let ext_len = min 7 (len - 1) in
+          let uca_ext = Array.sub uca (len - ext_len) ext_len in
+          let ext = "..." ^ (Glib.Utf8.from_unistring uca_ext) in
+          let rec adjust_string n len =
+            if n = len
+              then us
+              else begin
+                let ustr = (Glib.Utf8.from_unistring (Array.sub uca 0 n)) ^ ext in
+                Pango.Layout.set_text pango_layout ustr;
+                let ustr_pixels = fst (Pango.Layout.get_pixel_size pango_layout) in
+                if ustr_pixels < pixels
+                  then adjust_string (n + 1) len
+                  else ustr
+              end
+          in
+          adjust_string 0 len
+        end
+      in us'
     end
-  in us'
-
 
 
 let warning_box
diff -urN src/gtk2/gui/guiTypes2.ml src/gtk2/gui/guiTypes2.ml
--- src/gtk2/gui/guiTypes2.ml	2005-04-04 21:36:46.000000000 +0200
+++ src/gtk2/gui/guiTypes2.ml	2005-10-31 12:01:46.000000000 +0100
@@ -180,6 +180,10 @@
   GTreeDirectory of g_file_tree
 | GTreeFile of  res_info
 
+type source_slot = int
+let source_only = 0
+let source_has_slot = 1
+let source_has_upload = 3
 
 type source_info =
    {
@@ -202,14 +206,48 @@
     mutable source_upload_rate : float;
     mutable source_download_rate : float;
     mutable source_upload : string option;
-    mutable source_has_upload : bool;
+    mutable source_has_upload : source_slot;
     mutable source_availability : (int * string) list;     (* file_num, availability *)
     mutable source_files_requested : int list;             (* file_num *)
   }
 
+type razorback_stats =
+  {
+   mutable razorback_file_history      : string;
+   mutable razorback_file_rating       : string;
+   mutable razorback_file_avalaibility : int;
+   mutable razorback_file_completed    : int;
+  }
+
+type g_file_info = {
+    g_file_num : int;
+    g_file_network : int;
+
+    mutable g_file_comment : string;
+    mutable g_file_name : string;
+    mutable g_file_names : (string * ips_list) list;
+    mutable g_file_size : int64;
+    mutable g_file_downloaded : int64;
+    mutable g_file_active_sources : int;
+    mutable g_file_all_sources : int;
+    mutable g_file_state : file_state;
+    mutable g_file_chunks : string;
+    mutable g_file_availability : (int * string) list;
+    mutable g_file_sources : int list option;
+    mutable g_file_download_rate : float;
+    mutable g_file_format : format;
+    mutable g_file_chunks_age : int array;
+    mutable g_file_age : int;
+    mutable g_file_last_seen : int;
+    mutable g_file_priority : int;
+    mutable g_file_uids : Uid.t list;
+
+    mutable g_file_razorback_stats : razorback_stats option;
+  }
+
 type item_info =
-  File of file_info
-| Source of (source_info * int)   (* source_info, file_num*)
+  File of g_file_info
+| Source of (source_info * int)   (* source_info, file_num *)
 
 type item_index =
   File_num of int                 (* file_num *)
@@ -237,3 +275,15 @@
 | QF_COMBO of string ref
   
 | QF_HIDDEN of query_form list
+
+type shared_file =
+  {
+    g_shared_num : int;
+    g_shared_network : int;
+    mutable g_shared_filename : string;
+    mutable g_shared_size : int64;
+    mutable g_shared_uploaded : int64;
+    mutable g_shared_requests : int;
+    mutable g_shared_uids : Uid.t list;
+    mutable g_shared_last_seen : float;
+  }
